pro makefits,dirm,d,rmax,nx,gsig,fileroot,wave,Av

ilum=0  ;new version of code.  luminosity is already folded in
lum=1.
print,dirm,fileroot

filename=dirm+fileroot+'.dat'

;calculate ng, gaussian FWHM in pixels from gsig
;first compute pixel size 
rmaxi=rmax
pixsize=2.*rmaxi/float(nx)/d
ng=fix(gsig/pixsize)
if ng eq 0 then ng=1
print,'number of pixels for gaussian FWHM',ng

readdat,filename,nx,im
wvoigt=0.0  ;too tricky to explain how to use
ngwidth=30
if wvoigt lt 0.0001 then begin
print,'making gauss psf'
  makegauss,ng,img
endif else begin
  ;play with voigt profile
  img=psf_voigt_2d(ngwidth,wvoigt,ng)
endelse
;im=convol(im,img,/edge_truncate)
;this is much faster!
im=convolve(im,img,FT_PSF=psf_FT)

;normalize to distance
pc=3.0857d18
lsun=3.845d33
lum=lum*lsun
if ilum eq 1 then begin
  fnorm=lum/(4.*!pi)/d^2/pc/pc
endif else begin
  fnorm=lsun/pc/pc/d^2/(4.*!pi)
endelse
print,'fnorm',fnorm
;flux is in ergs/cm^2/Hz/s
c=2.9979e10
;convert to Jy
fnorm1=fnorm*1.e23
fnorm2=fnorm*1.e23
fnorm3=fnorm*1.e23

im=im*fnorm1

print,'total flux in mJy',total(im)*1000.

;okay, this is Jy/pixel.  should convert to something independent of
;pixel size.  favorite units seem to be MJy/Sr
;pixel size is in arcsec, need to square it
;also, convert to MJy (mega...), so divide by 10^6
;there are 206,265^2 square " per steradian
fact=1./pixsize^2/1.e6*(206265.)^2
print,'fact,pixsize',fact,pixsize
im=im*fact
help,im

;add in foreground reddening
readcol,'../models/parfiles/kmh.par',klam,junk1,junk2,kkap
kapnew=interpol(kkap,klam,wave)
kapv=interpol(kkap,klam,0.55)
taul=kapnew/kapv/1.086*Av
extinct=exp(-taul)
im=im*extinct

mkhdr,head,im
sxaddpar,head,'PXSCAL1',pixsize,' Arcsec','DATE'
sxaddpar,head,'PXSCAL2',pixsize,' Arcsec','DATE'

writefits,fileroot+'.fits', im, head

end
