C     ********************************************************************
C     Function to calculate dust temperature from condition of radiative
C     equilibrium
C     ********************************************************************
      real function dusttemp(i,j,k,na,T0,rstar,tstar,nphot,idust2)
      
      implicit none
      
c     include 'kepler.com'
      include 'dust.com'
c     include 'star.com'
      include 'grid.txt'
      
      integer i,j,k             ! grid cell index 
c     +        ,na    ! number of photons absorbed
     +     ,nphot,idust2
c     real T0       ! initial guess for temperature
      real T0,Td,Told,eps
      real*8 rstar,tstar,na
      
      real KapP
      
      data eps /1.e-5/
      
c     print *,T0*11605.,i,j,na
      
      if (T0 .ne. 0.d0) then
         Td=T0
      else
         Td=0.1
      endif
      Told=0.5*Td
      
      do while( abs(Td-Told) .gt. eps*Td)
         
         Told=Td
         
c     print*,na,td*11605.,KapP(Td),KapP(Td/2.)
c     print*,massarr(i,j,k),i,j,k
         
         Td=Tstar*( (na*3.1415927*Rstar*Rstar) /
     +        (nphot*kappav(idust2)* KapP(Td,idust2)) )**0.25
         Td=Td*263818.1192/massarr(i,j,k) !sqrt(rsun) 
         
c     Td=247277.*( (na*0.918) /
c     +        (4.*nphot*massarr(i,j,k)*kappav* KapP(Td)) )**0.25
c     Td=247277.*( (na*0.918) /
c     +        (4.*nphot*kappav* KapP(Td)) )**0.25
c     Td=Td/massarr(i,j,k)
         
         if (Td.gt.1600./11605.) then
            nodust(i,j,k)=.true.
            Td=1600./11605.
         endif
c     Td=min(Td,1600./11605.)
         Td=max(Td,0.1/11605.)
c     print*,'td',td
         
c     print *,Td*11605. 
         
      end do
      
      dusttemp=Td
            
      return
      end
      
