      subroutine filt

c     read in filter functions for the images

      implicit none

      include 'filt.txt'

      integer i,nf,ifilt,ich,ich2
      character junk*5,filnam*20
      real*8 rjunk,fact,w,f,fint,w_ave,f_peak,w_peak,w_half1,w_half2
     $ ,w_avew,fintw

      fact=2.9979e14
c     fact=1.2398

       data filtnames  /'2J.txt','2H.txt','2K.txt','I1.txt','I2.txt'
     $ ,'I3.txt','I4.txt','M1.txt','M2.txt','M3.txt','S1.txt','S2.txt'
     $ ,'S3.txt','S4.txt','XA.txt','XC.txt','XD.txt','XE.txt'
     $ ,'AC.txt','N2.txt'
     $ ,'Z1.txt','Z2.txt'/

       data nwfilt /108,59,76,506,428,371,422,129,112,401
     $  ,19,33,22,17,632,319,403,1097,318,800,7,7/

c     nfilt is number of filter files
c     loop over filter files
      do ifilt=1,nfilt
         fint=0.d0
         filnam='../parfiles/'//filtnames(ifilt)
         print*,filnam
c        nf=number of lines in this filter file. subtract 1 for the header
         nf=nwfilt(ifilt)-1

c        read in filter file
         f_peak=0.
         open(unit=14,file=filnam,status='unknown')
         read(14,*) junk
	 do i=1,nf
            read(14,*) w,f 
c     convert wavelength to frequency
            filtwave(i,ifilt)=fact/w
            filtphi(i,ifilt)=f
            if (f.gt.f_peak) then
              f_peak=f
              w_peak=filtwave(i,ifilt)
            endif
         enddo
         f_peak=f_peak/2.   !for FWHM calculation later on
         print*,'w_peak,f_peak',fact/w_peak,f_peak
         close(14)

c     integrate filter to determine normalization factor
c     tom says they are already normalized but let's check
         fint=0.d0
         w_ave=0.d0
         w_avew=0.d0
         fintw=0.d0
         do i=1,nf-1
            fint=0.5*(filtphi(i+1,ifilt)+filtphi(i,ifilt))*
     $        (filtwave(i+1,ifilt)-filtwave(i,ifilt))+fint
            fintw=0.5*(filtphi(i+1,ifilt)+filtphi(i,ifilt))*
     $        (fact/filtwave(i,ifilt)-fact/filtwave(i+1,ifilt))+fintw
            w_ave=w_ave+(filtwave(i+1,ifilt)-filtwave(i,ifilt))*
     $         0.5*(filtphi(i+1,ifilt)+filtphi(i,ifilt))*
     $         0.5*(filtwave(i+1,ifilt)+filtwave(i,ifilt))
            w_avew=w_avew+(fact/filtwave(i,ifilt)-
     $         fact/filtwave(i+1,ifilt))*
     $         0.5*(filtphi(i+1,ifilt)+filtphi(i,ifilt))*
     $         0.5*(fact/filtwave(i+1,ifilt)
     $         +fact/filtwave(i,ifilt))
         enddo
         w_ave=w_ave/fint
         w_avew=w_avew/fintw
         print*,'norm factor',fint

c     calculate FWHM
         ich=1
         ich2=1
         do i=1,nf
c            print*,'calculating w_half1'
            if (ich.eq.1) then
c            print*,'ich=1',fact/filtwave(i,ifilt)
c     $    ,filtphi(i,ifilt),f_peak
	       if (filtphi(i,ifilt).gt.f_peak) then
                  w_half1=filtwave(i,ifilt)
c	          print*,'wave,filtphi',fact/filtwave(i,ifilt),filtphi(i,ifilt)
                  ich=0
               endif
            endif 
c            print*,'filtwave,wpeak',fact/filtwave(i,ifilt),fact/w_peak
            if (filtwave(i,ifilt).gt.w_peak) then
c               print*,'calculating w_half2'
c               print*,fact/filtwave(i,ifilt),f_peak
               if (ich2.eq.1) then
c                 print*,'ich2 eq 1',filtphi(i,ifilt),f_peak
	         if (filtphi(i,ifilt).lt.f_peak) then
                    w_half2=filtwave(i,ifilt)
                    ich2=0
                 endif
               endif
            endif
         enddo
         print*,'wavelengths near half-peak',fact/w_half2,fact/w_half1
         print*,'FWHM',fact/w_half1-fact/w_half2
         print*,'wave average, freq. space',fact/w_ave
         print*,'wave average, wavelength space',w_avew

c     rescale filter
         do i=1,nf
            filtphi(i,ifilt)=filtphi(i,ifilt)/fint
         enddo
      enddo

      end

